/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.100 Revision 1.121
1# Copyright 1999-2011 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.100 2011/11/19 20:31:12 pesa Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.121 2012/03/01 15:06:00 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Qt herd <qt@gentoo.org> 7# Qt herd <qt@gentoo.org>
8# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12inherit base eutils multilib toolchain-funcs flag-o-matic versionator 12inherit base eutils multilib toolchain-funcs flag-o-matic versionator
13 13
14MY_PV=${PV/_/-} 14MY_PV=${PV/_/-}
15MY_P=qt-everywhere-opensource-src-${MY_PV} 15MY_P=qt-everywhere-opensource-src-${MY_PV}
16 16
17HOMEPAGE="http://qt.nokia.com/" 17HOMEPAGE="http://qt.nokia.com/ http://qt-project.org/"
18SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz" 18SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
19LICENSE="|| ( LGPL-2.1 GPL-3 )" 19LICENSE="|| ( LGPL-2.1 GPL-3 )"
20 20
21IUSE="aqua debug pch" 21IUSE="aqua debug pch"
22 22
26 26
27if version_is_at_least 4.7.99999999; then 27if version_is_at_least 4.7.99999999; then
28 IUSE+=" c++0x qpa" 28 IUSE+=" c++0x qpa"
29fi 29fi
30 30
31DEPEND="dev-util/pkgconfig"
31RDEPEND=" 32RDEPEND="
32 !<x11-libs/qt-assistant-${PV} 33 !<x11-libs/qt-assistant-${PV}
33 !>x11-libs/qt-assistant-${PV}-r9999 34 !>x11-libs/qt-assistant-${PV}-r9999
34 !<x11-libs/qt-core-${PV} 35 !<x11-libs/qt-core-${PV}
35 !>x11-libs/qt-core-${PV}-r9999 36 !>x11-libs/qt-core-${PV}-r9999
43 !>x11-libs/qt-gui-${PV}-r9999 44 !>x11-libs/qt-gui-${PV}-r9999
44 !<x11-libs/qt-multimedia-${PV} 45 !<x11-libs/qt-multimedia-${PV}
45 !>x11-libs/qt-multimedia-${PV}-r9999 46 !>x11-libs/qt-multimedia-${PV}-r9999
46 !<x11-libs/qt-opengl-${PV} 47 !<x11-libs/qt-opengl-${PV}
47 !>x11-libs/qt-opengl-${PV}-r9999 48 !>x11-libs/qt-opengl-${PV}-r9999
49 !<x11-libs/qt-openvg-${PV}
50 !>x11-libs/qt-openvg-${PV}-r9999
48 !<x11-libs/qt-phonon-${PV} 51 !<x11-libs/qt-phonon-${PV}
49 !>x11-libs/qt-phonon-${PV}-r9999 52 !>x11-libs/qt-phonon-${PV}-r9999
50 !<x11-libs/qt-qt3support-${PV} 53 !<x11-libs/qt-qt3support-${PV}
51 !>x11-libs/qt-qt3support-${PV}-r9999 54 !>x11-libs/qt-qt3support-${PV}-r9999
52 !<x11-libs/qt-script-${PV} 55 !<x11-libs/qt-script-${PV}
65 68
66S=${WORKDIR}/${MY_P} 69S=${WORKDIR}/${MY_P}
67 70
68# @FUNCTION: qt4-build_pkg_setup 71# @FUNCTION: qt4-build_pkg_setup
69# @DESCRIPTION: 72# @DESCRIPTION:
70# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 73# Sets up PATH and LD_LIBRARY_PATH.
71qt4-build_pkg_setup() { 74qt4-build_pkg_setup() {
72 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX= 75 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
73 76
74 # Protect users by not allowing downgrades between releases 77 # Protect users by not allowing downgrades between releases
75 # Downgrading revisions within the same release should be allowed 78 # Downgrading revisions within the same release should be allowed
108 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 111 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
109 ${QT4_EXTRACT_DIRECTORIES}" 112 ${QT4_EXTRACT_DIRECTORIES}"
110 fi 113 fi
111 114
112 # Make sure ebuilds use the required EAPI 115 # Make sure ebuilds use the required EAPI
113 if [[ ${EAPI} != [23] ]]; then 116 if [[ ${EAPI} != [234] ]]; then
114 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using" 117 eerror "The qt4-build eclass requires EAPI 2,3 or 4 but this ebuild is using"
115 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be" 118 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
116 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail." 119 eerror "fixed. Using qt4-build eclass without EAPI 2,3 or 4 will fail."
117 die "qt4-build eclass requires EAPI=2 or EAPI=3" 120 die "qt4-build eclass requires EAPI 2,3 or 4"
118 fi 121 fi
119 122
120 if ! version_is_at_least 4.1 $(gcc-version); then 123 if ! version_is_at_least 4.1 $(gcc-version); then
121 ewarn "Using a GCC version lower than 4.1 is not supported!" 124 ewarn "Using a GCC version lower than 4.1 is not supported!"
122 fi 125 fi
123} 126}
124 127
125# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 128# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
126# @DESCRIPTION: 129# @DESCRIPTION:
127# Arguments for build_target_directories. Takes the directories, in which the 130# Arguments for build_target_directories. Takes the directories in which the
128# code should be compiled. This is a space-separated list 131# code should be compiled. This is a space-separated list.
129 132
130# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES 133# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
131# @DESCRIPTION: 134# @DESCRIPTION:
132# Space separated list including the directories that will be extracted from Qt 135# Space-separated list including the directories that will be extracted from
133# tarball 136# Qt tarball.
134 137
135# @FUNCTION: qt4-build_src_unpack 138# @FUNCTION: qt4-build_src_unpack
136# @DESCRIPTION: 139# @DESCRIPTION:
137# Unpacks the sources 140# Unpacks the sources.
138qt4-build_src_unpack() { 141qt4-build_src_unpack() {
139 setqtenv 142 setqtenv
140 local unpack_p="${MY_P}" 143
141 case "${PV}" in 144 local tarball="${MY_P}.tar.gz" target= targets=
142 4.8.0_*)
143 unpack_p="qt-everywhere-opensource-src-${PV/_*}"
144 ;;
145 esac
146 local target targets=
147 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \ 145 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
148 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 146 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
149 ${QT4_EXTRACT_DIRECTORIES}; do 147 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
148 do
150 targets+=" ${unpack_p}/${target}" 149 targets+="${MY_P}/${target} "
151 done 150 done
152 151
152 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
153 echo tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} 153 tar -xzf "${DISTDIR}/${tarball}" ${targets}
154 tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die 154 eend $? || die "failed to unpack"
155 case "${PV}" in
156 4.8.0_*)
157 mv ${WORKDIR}/qt-everywhere-opensource-src-${PV/_*} \
158 ${WORKDIR}/qt-everywhere-opensource-src-${MY_PV}
159 ;;
160 esac
161} 155}
162 156
163# @ECLASS-VARIABLE: PATCHES 157# @ECLASS-VARIABLE: PATCHES
158# @DEFAULT_UNSET
164# @DESCRIPTION: 159# @DESCRIPTION:
165# In case you have patches to apply, specify them in PATCHES variable. Make sure 160# PATCHES array variable containing all various patches to be applied.
166# to specify the full path. This variable is necessary for src_prepare phase. 161# This variable is expected to be defined in global scope of ebuild.
167# example: 162# Make sure to specify the full path. This variable is utilised in
168# PATCHES="${FILESDIR}"/mypatch.patch 163# src_unpack/src_prepare phase, based on EAPI.
169# ${FILESDIR}"/mypatch2.patch"
170# 164#
165# @CODE
166# PATCHES=( "${FILESDIR}/mypatch.patch"
167# "${FILESDIR}/patches_folder/" )
168# @CODE
171 169
172# @FUNCTION: qt4-build_src_prepare 170# @FUNCTION: qt4-build_src_prepare
173# @DESCRIPTION: 171# @DESCRIPTION:
174# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 172# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
175# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 173# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
176qt4-build_src_prepare() { 174qt4-build_src_prepare() {
177 setqtenv 175 setqtenv
178 cd "${S}" 176 cd "${S}"
179
180 # fix qt 4.7 regression that skips -fvisibility=hidden
181 if version_is_at_least "4.7.0_beta1"; then
182 sed -e "s/^gcc|g++)/*gcc|*g++)/" \
183 -i config.tests/unix/fvisibility.test ||
184 die "visibility fixing sed failed"
185 fi
186 177
187 if version_is_at_least "4.7"; then 178 if version_is_at_least "4.7"; then
188 # fix libX11 dependency on non X packages 179 # fix libX11 dependency on non X packages
189 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns" 180 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
190 has ${PN} ${nolibx11_pkgs} && qt_nolibx11 181 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
196 # provide a proper macx-g++-64 187 # provide a proper macx-g++-64
197 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 188 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
198 189
199 sed -e '/^CONFIG/s:app_bundle::' \ 190 sed -e '/^CONFIG/s:app_bundle::' \
200 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 191 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
201 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 192 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
202 fi 193 fi
203 194
204 if [[ ${PN} != qt-core ]]; then 195 if [[ ${PN} != qt-core ]]; then
205 skip_qmake_build 196 skip_qmake_build
206 skip_project_generation 197 skip_project_generation
207 symlink_binaries_to_buildtree 198 symlink_binaries_to_buildtree
208 fi 199 fi
209 200
210 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 201 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
211 # qmake bus errors with -O2 but -O3 works 202 # qmake bus errors with -O2 but -O3 works
212 replace-flags -O2 -O3 203 replace-flags -O2 -O3
213 fi 204 fi
214 205
215 # Bug 178652 206 # Bug 178652
226 ewarn "disabled." 217 ewarn "disabled."
227 append-flags -std=c++0x 218 append-flags -std=c++0x
228 fi 219 fi
229 220
230 # Unsupported old gcc versions - hardened needs this :( 221 # Unsupported old gcc versions - hardened needs this :(
231 if [[ $(gcc-major-version) -lt 4 ]] ; then 222 if [[ $(gcc-major-version) -lt 4 ]]; then
232 ewarn "Appending -fno-stack-protector to CXXFLAGS" 223 ewarn "Appending -fno-stack-protector to CXXFLAGS"
233 append-cxxflags -fno-stack-protector 224 append-cxxflags -fno-stack-protector
234 # Bug 253127 225 # Bug 253127
235 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 226 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
236 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 227 -i mkspecs/common/g++.conf || die
237 fi 228 fi
238 229
239 # Bug 261632 230 # Bug 261632
240 if use ppc64; then 231 if use ppc64; then
241 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 232 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
242 append-flags -mminimal-toc 233 append-flags -mminimal-toc
243 fi 234 fi
244 235
245 # Bug 282984 && Bug 295530 236 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
246 sed -e "s:\(^SYSTEM_VARIABLES\):CC=\"$(tc-getCC)\"\nCXX=\"$(tc-getCXX)\"\nCFLAGS=\"${CFLAGS}\"\nCXXFLAGS=\"${CXXFLAGS}\"\nLDFLAGS=\"${LDFLAGS}\"\n\1:" \ 237 sed -e "/^SYSTEM_VARIABLES=/i \
247 -i configure || die "sed qmake compilers failed" 238 CC='$(tc-getCC)'\n\
239 CXX='$(tc-getCXX)'\n\
240 CFLAGS='${CFLAGS}'\n\
241 CXXFLAGS='${CXXFLAGS}'\n\
242 LDFLAGS='${LDFLAGS}'\n" \
243 -i configure \
244 || die "sed SYSTEM_VARIABLES failed"
248 245
249 # Bug 321335 246 # Respect CC, CXX, LINK and *FLAGS in config.tests
250 if version_is_at_least 4.6; then 247 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
251 find ./config.tests/unix -name "*.test" -type f -exec grep -lZ \$MAKE '{}' \; | \ 248 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
252 xargs -0 \ 249 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
253 sed -e "s:\(\$MAKE\):\1 CC=\"$(tc-getCC)\" CXX=\"$(tc-getCXX)\" LD=\"$(tc-getCXX)\" LINK=\"$(tc-getCXX)\":g" \ 250 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
254 -i || die "sed test compilers failed" 251 || die "sed config.tests failed"
255 fi 252
253 # Strip predefined CFLAGS from mkspecs (bug 312689)
254 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
256 255
257 # Bug 172219 256 # Bug 172219
258 sed -e "s:X11R6/::" \ 257 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
259 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
260 258
261 if [[ ${CHOST} == *-darwin* ]]; then 259 if [[ ${CHOST} == *-darwin* ]]; then
262 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 260 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
263 # crippled (by design) :/ 261 # crippled (by design) :/
262 sed \
264 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 263 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
265 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 264 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
266 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 265 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
267 -e "s:-arch\s\w*::g" \ 266 -e "s:-arch\s\w*::g" \
268 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 267 -i mkspecs/common/mac-g++.conf \
268 || die "sed mkspecs/common/mac-g++.conf failed"
269 269
270 # Fix configure's -arch settings that appear in qmake/Makefile and also 270 # Fix configure's -arch settings that appear in qmake/Makefile and also
271 # fix arch handling (automagically duplicates our -arch arg and breaks 271 # fix arch handling (automagically duplicates our -arch arg and breaks
272 # pch). Additionally disable Xarch support. 272 # pch). Additionally disable Xarch support.
273 sed \ 273 sed \
278 -e "s:-arch \$i::" \ 278 -e "s:-arch \$i::" \
279 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 279 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
280 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 280 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
281 -e "s:-Xarch_x86_64::g" \ 281 -e "s:-Xarch_x86_64::g" \
282 -e "s:-Xarch_ppc64::g" \ 282 -e "s:-Xarch_ppc64::g" \
283 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 283 -i configure mkspecs/common/mac-g++.conf \
284 || die "sed -arch/-Xarch failed"
284 285
285 # On Snow Leopard don't fall back to 10.5 deployment target. 286 # On Snow Leopard don't fall back to 10.5 deployment target.
286 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 287 if [[ ${CHOST} == *-apple-darwin10 ]]; then
287 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 288 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
288 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 289 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
289 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 290 -i configure mkspecs/common/mac-g++.conf \
291 || die "sed deployment target failed"
290 fi 292 fi
291 fi 293 fi
292 294
293 # this one is needed for all systems with a separate -liconv, apart from 295 # this one is needed for all systems with a separate -liconv, apart from
294 # Darwin, for which the sources already cater for -liconv 296 # Darwin, for which the sources already cater for -liconv
295 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 297 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
296 sed \ 298 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
297 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
298 -i config.tests/unix/iconv/iconv.pro \ 299 -i config.tests/unix/iconv/iconv.pro \
299 || die "sed on iconv.pro failed" 300 || die "sed iconv.pro failed"
300 fi 301 fi
301 302
302 # we need some patches for Solaris 303 # we need some patches for Solaris
303 sed -i \
304 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 304 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
305 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 305 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
306 # use GCC over SunStudio 306 # use GCC over SunStudio
307 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 307 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
308 # don't flirt with non-Prefix stuff, we're quite possessive 308 # do not flirt with non-Prefix stuff, we're quite possessive
309 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 309 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
310 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 310 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
311 # strip predefined CFLAGS from qmake ( bug #312689 )
312 sed -i '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf
313 311
314 base_src_prepare 312 base_src_prepare
315} 313}
316 314
317# @FUNCTION: qt4-build_src_configure 315# @FUNCTION: qt4-build_src_configure
318# @DESCRIPTION: 316# @DESCRIPTION:
319# Default configure phase 317# Default configure phase
320qt4-build_src_configure() { 318qt4-build_src_configure() {
321 setqtenv 319 setqtenv
322 myconf="$(standard_configure_options) ${myconf}" 320
321 local conf="
322 -prefix ${QTPREFIXDIR}
323 -bindir ${QTBINDIR}
324 -libdir ${QTLIBDIR}
325 -docdir ${QTDOCDIR}
326 -headerdir ${QTHEADERDIR}
327 -plugindir ${QTPLUGINDIR}
328 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
329 -datadir ${QTDATADIR}
330 -translationdir ${QTTRANSDIR}
331 -sysconfdir ${QTSYSCONFDIR}
332 -examplesdir ${QTEXAMPLESDIR}
333 -demosdir ${QTDEMOSDIR}
334 -opensource -confirm-license
335 -shared -fast -largefile -stl -verbose
336 -nomake examples -nomake demos"
337
338 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
339 # $(tc-arch). Therefore we convert it to supported values.
340 case "$(tc-arch)" in
341 amd64|x64-*) conf+=" -arch x86_64" ;;
342 ppc-macos) conf+=" -arch ppc" ;;
343 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
344 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
345 x86-macos) conf+=" -arch x86" ;;
346 x86|x86-*) conf+=" -arch i386" ;;
347 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
348 hppa|sh) conf+=" -arch generic" ;;
349 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
350 esac
351
352 conf+=" -platform $(qt_mkspecs_dir)"
353
354 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
355
356 # debug/release
357 if use debug; then
358 conf+=" -debug"
359 else
360 conf+=" -release"
361 fi
362 conf+=" -no-separate-debug-info"
363
364 # exceptions USE flag
365 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
366
367 # disable RPATH on Qt >= 4.8 (bug 380415)
368 version_is_at_least 4.8 && conf+=" -no-rpath"
369
370 # precompiled headers don't work on hardened, where the flag is masked
371 conf+=" $(qt_use pch)"
372
373 # -reduce-relocations
374 # This flag seems to introduce major breakage to applications,
375 # mostly to be seen as a core dump with the message "QPixmap: Must
376 # construct a QApplication before a QPaintDevice" on Solaris.
377 # -- Daniel Vergien
378 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
323 379
324 # this one is needed for all systems with a separate -liconv, apart from 380 # this one is needed for all systems with a separate -liconv, apart from
325 # Darwin, for which the sources already cater for -liconv 381 # Darwin, for which the sources already cater for -liconv
326 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 382 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
327 myconf+=" -liconv" 383 conf+=" -liconv"
384 fi
328 385
329 if use_if_iuse glib; then 386 if use_if_iuse glib; then
330 # use -I, -L and -l from configure
331 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 387 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
332 # avoid the -pthread argument 388 # avoid the -pthread argument
333 myconf+=" ${glibflags//-pthread}" 389 conf+=" ${glibflags//-pthread}"
334 unset glibflags 390 unset glibflags
335 fi 391 fi
336 392
337 if use_if_iuse qpa; then 393 if use_if_iuse qpa; then
338 ewarn 394 ewarn
339 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely" 395 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
340 ewarn "known as Qt Lighthouse. If you are not sure what that is, then" 396 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
341 ewarn "disable it before reporting any bugs related to this useflag." 397 ewarn "disable it before reporting any bugs related to this useflag."
342 ewarn 398 ewarn
343 myconf+=" -qpa" 399 conf+=" -qpa"
344 fi 400 fi
345 401
346 if use aqua ; then 402 if use aqua; then
347 # On (snow) leopard use the new (frameworked) cocoa code. 403 # On (snow) leopard use the new (frameworked) cocoa code.
348 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 404 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
349 myconf+=" -cocoa -framework" 405 conf+=" -cocoa -framework"
406 # We need the source's headers, not the installed ones.
407 conf+=" -I${S}/include"
408 # Add hint for the framework location.
409 conf+=" -F${QTLIBDIR}"
350 410
351 # We are crazy and build cocoa + qt3support :-) 411 # We are crazy and build cocoa + qt3support :-)
352 if use qt3support; then 412 if use qt3support; then
353 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 413 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
354 -i configure 414 -i configure || die
355 fi 415 fi
356 416 else
357 # We need the source's headers, not the installed ones. 417 conf+=" -no-framework"
358 myconf+=" -I${S}/include"
359
360 # Add hint for the framework location.
361 myconf+=" -F${QTLIBDIR}"
362 fi 418 fi
363 else 419 else
364 # freetype2 include dir is non-standard, thus include it on configure 420 # freetype2 include dir is non-standard, thus pass it to configure
365 # use -I from configure
366 myconf+=" $(pkg-config --cflags freetype2)" 421 conf+=" $(pkg-config --cflags-only-I freetype2)"
367 fi 422 fi
368 423
369 # Disable SSE4.x, since auto-detection is currently broken 424 conf+=" ${myconf}"
370 # Upstream bug http://bugreports.qt.nokia.com/browse/QTBUG-13623 425 myconf=
371 [[ ${PV} == "4.7.1" ]] && myconf+=" -no-sse4.1 -no-sse4.2"
372 426
373 echo ./configure ${myconf} 427 echo ./configure ${conf}
374 ./configure ${myconf} || die "./configure failed" 428 ./configure ${conf} || die "./configure failed"
375 myconf=""
376 429
377 prepare_directories ${QT4_TARGET_DIRECTORIES} 430 prepare_directories ${QT4_TARGET_DIRECTORIES}
378} 431}
379 432
380# @FUNCTION: qt4-build_src_compile 433# @FUNCTION: qt4-build_src_compile
388 441
389# @FUNCTION: qt4-build_src_test 442# @FUNCTION: qt4-build_src_test
390# @DESCRIPTION: 443# @DESCRIPTION:
391# Runs tests only in target directories. 444# Runs tests only in target directories.
392qt4-build_src_test() { 445qt4-build_src_test() {
446 # QtMultimedia does not have any test suite (bug #332299)
447 [[ ${PN} == "qt-multimedia" ]] && return
448
393 for dir in ${QT4_TARGET_DIRECTORIES}; do 449 for dir in ${QT4_TARGET_DIRECTORIES}; do
394 emake -j1 check -C ${dir} 450 emake -j1 check -C ${dir}
395 done 451 done
396} 452}
397 453
398# @FUNCTION: fix_includes 454# @FUNCTION: fix_includes
399# @DESCRIPTION: 455# @DESCRIPTION:
400# For MacOSX we need to add some symlinks when frameworks are 456# For MacOS X we need to add some symlinks when frameworks are
401# being used, to avoid complications with some more or less stupid packages. 457# being used, to avoid complications with some more or less stupid packages.
402fix_includes() { 458fix_includes() {
403 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 459 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
404 # Some packages tend to include <Qt/...> 460 # Some packages tend to include <Qt/...>
405 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 461 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
406 462
407 # Fake normal headers when frameworks are installed... eases life later on 463 # Fake normal headers when frameworks are installed... eases life later on
408 local dest f 464 local dest f h
409 for frw in "${D}${QTLIBDIR}"/*.framework; do 465 for frw in "${D}${QTLIBDIR}"/*.framework; do
410 [[ -e "${frw}"/Headers ]] || continue 466 [[ -e "${frw}"/Headers ]] || continue
411 f=$(basename ${frw}) 467 f=$(basename ${frw})
412 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 468 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
413 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 469 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}"
432 install_qconfigs 488 install_qconfigs
433 fix_library_files 489 fix_library_files
434 fix_includes 490 fix_includes
435 491
436 # remove .la files since we are building only shared Qt libraries 492 # remove .la files since we are building only shared Qt libraries
437 find "${D}"${QTLIBDIR} -name "*.la" -print0 | xargs -0 rm 493 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
438} 494}
439 495
440# @FUNCTION: setqtenv 496# @FUNCTION: setqtenv
497# @INTERNAL
441setqtenv() { 498setqtenv() {
442 # Set up installation directories 499 # Set up installation directories
443 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
444 QTPREFIXDIR=${EPREFIX}/usr 500 QTPREFIXDIR=${EPREFIX}/usr
445 QTBINDIR=${EPREFIX}/usr/bin 501 QTBINDIR=${EPREFIX}/usr/bin
446 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 502 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
447 QMAKE_LIBDIR_QT=${QTLIBDIR}
448 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 503 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
449 QTDATADIR=${EPREFIX}/usr/share/qt4
450 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 504 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
451 QTHEADERDIR=${EPREFIX}/usr/include/qt4 505 QTHEADERDIR=${EPREFIX}/usr/include/qt4
452 QTPLUGINDIR=${QTLIBDIR}/plugins 506 QTPLUGINDIR=${QTLIBDIR}/plugins
507 QTIMPORTDIR=${QTLIBDIR}/imports
508 QTDATADIR=${EPREFIX}/usr/share/qt4
509 QTTRANSDIR=${QTDATADIR}/translations
453 QTSYSCONFDIR=${EPREFIX}/etc/qt4 510 QTSYSCONFDIR=${EPREFIX}/etc/qt4
454 QTTRANSDIR=${QTDATADIR}/translations
455 QTEXAMPLESDIR=${QTDATADIR}/examples 511 QTEXAMPLESDIR=${QTDATADIR}/examples
456 QTDEMOSDIR=${QTDATADIR}/demos 512 QTDEMOSDIR=${QTDATADIR}/demos
513 QMAKE_LIBDIR_QT=${QTLIBDIR}
457 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 514 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
515
458 PLATFORM=$(qt_mkspecs_dir) 516 PLATFORM=$(qt_mkspecs_dir)
459 517
460 unset QMAKESPEC 518 unset QMAKESPEC
461}
462
463# @FUNCTION: standard_configure_options
464# @DESCRIPTION:
465# Sets up some standard configure options, like libdir (if necessary), whether
466# debug info is wanted or not.
467standard_configure_options() {
468 local myconf=
469
470 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
471
472 # Disable visibility explicitly if gcc version isn't 4
473 if [[ $(gcc-major-version) -lt 4 ]]; then
474 myconf+=" -no-reduce-exports"
475 fi
476
477 # precompiled headers doesn't work on hardened, where the flag is masked.
478 myconf+=" $(qt_use pch)"
479
480 if use debug; then
481 myconf+=" -debug"
482 else
483 myconf+=" -release"
484 fi
485 myconf+=" -no-separate-debug-info"
486
487 use aqua && myconf+=" -no-framework"
488
489 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
490 # $(tc-arch). Therefore we convert it to supported values.
491 case "$(tc-arch)" in
492 amd64|x64-*) myconf+=" -arch x86_64" ;;
493 ppc-macos) myconf+=" -arch ppc" ;;
494 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
495 sparc|sparc-*) myconf+=" -arch sparc" ;;
496 x86-macos) myconf+=" -arch x86" ;;
497 x86|x86-*) myconf+=" -arch i386" ;;
498 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;;
499 hppa|sh) myconf+=" -arch generic" ;;
500 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
501 esac
502
503 # exceptions USE flag
504 local exceptions="-exceptions"
505 in_iuse exceptions && exceptions="$(qt_use exceptions)"
506
507 # note about -reduce-relocations:
508 # That flag seems to introduce major breakage to applications,
509 # mostly to be seen as a core dump with the message "QPixmap: Must
510 # construct a QApplication before a QPaintDevice" on Solaris
511 # -- Daniel Vergien
512 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
513
514 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
515 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
516 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
517 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
518 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
519 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
520 ${exceptions}
521 -nomake examples -nomake demos"
522
523 echo "${myconf}"
524} 519}
525 520
526# @FUNCTION: prepare_directories 521# @FUNCTION: prepare_directories
527# @USAGE: < directories > 522# @USAGE: < directories >
523# @INTERNAL
528# @DESCRIPTION: 524# @DESCRIPTION:
529# Generates makefiles for the directories set in $QT4_TARGET_DIRECTORIES 525# Generates Makefiles for the given list of directories.
530prepare_directories() { 526prepare_directories() {
531 for x in "$@"; do 527 for x in "$@"; do
532 pushd "${S}"/${x} >/dev/null 528 pushd "${S}"/${x} >/dev/null || die
533 einfo "Running qmake in: ${x}" 529 einfo "Running qmake in: ${x}"
534 # avoid running over the maximum argument number, bug #299810 530 # avoid running over the maximum argument number, bug #299810
535 { 531 {
536 echo "${S}"/mkspecs/common/*.conf 532 echo "${S}"/mkspecs/common/*.conf
537 find "${S}" -name '*.pr[io]' 533 find "${S}" -name '*.pr[io]'
538 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die 534 } | xargs sed -i \
535 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
536 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
537 || die
539 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 538 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
540 popd >/dev/null 539 popd >/dev/null || die
541 done 540 done
542} 541}
543 542
544 543
545# @FUNCTION: build_directories 544# @FUNCTION: build_directories
546# @USAGE: < directories > 545# @USAGE: < directories >
546# @INTERNAL
547# @DESCRIPTION: 547# @DESCRIPTION:
548# Compiles the code in $QT4_TARGET_DIRECTORIES 548# Compiles the code in the given list of directories.
549build_directories() { 549build_directories() {
550 for x in "$@"; do 550 for x in "$@"; do
551 pushd "${S}"/${x} >/dev/null 551 pushd "${S}"/${x} >/dev/null || die
552 emake CC="$(tc-getCC)" \ 552 emake CC="$(tc-getCC)" \
553 CXX="$(tc-getCXX)" \ 553 CXX="$(tc-getCXX)" \
554 LINK="$(tc-getCXX)" || die "emake failed" 554 LINK="$(tc-getCXX)" || die "emake failed"
555 popd >/dev/null 555 popd >/dev/null || die
556 done 556 done
557} 557}
558 558
559# @FUNCTION: install_directories 559# @FUNCTION: install_directories
560# @USAGE: < directories > 560# @USAGE: < directories >
561# @INTERNAL
561# @DESCRIPTION: 562# @DESCRIPTION:
562# run emake install in the given directories, which are separated by spaces 563# Runs emake install in the given directories, which are separated by spaces.
563install_directories() { 564install_directories() {
564 for x in "$@"; do 565 for x in "$@"; do
565 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 566 pushd "${S}"/${x} >/dev/null || die
566 emake INSTALL_ROOT="${D}" install || die "emake install failed" 567 emake INSTALL_ROOT="${D}" install || die "emake install failed"
567 popd >/dev/null || die "Can't popd from ${S}/${x}" 568 popd >/dev/null || die
568 done 569 done
569} 570}
570 571
571# @ECLASS-VARIABLE: QCONFIG_ADD 572# @ECLASS-VARIABLE: QCONFIG_ADD
572# @DESCRIPTION: 573# @DESCRIPTION:
582# @DESCRIPTION: 583# @DESCRIPTION:
583# List variables that should be defined at the top of QtCore/qconfig.h 584# List variables that should be defined at the top of QtCore/qconfig.h
584: ${QCONFIG_DEFINE:=} 585: ${QCONFIG_DEFINE:=}
585 586
586# @FUNCTION: install_qconfigs 587# @FUNCTION: install_qconfigs
588# @INTERNAL
587# @DESCRIPTION: 589# @DESCRIPTION:
588# Install gentoo-specific mkspecs configurations 590# Install gentoo-specific mkspecs configurations.
589install_qconfigs() { 591install_qconfigs() {
590 local x 592 local x
591 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 593 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
592 for x in QCONFIG_ADD QCONFIG_REMOVE; do 594 for x in QCONFIG_ADD QCONFIG_REMOVE; do
593 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 595 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
604 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 606 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
605 fi 607 fi
606} 608}
607 609
608# @FUNCTION: generate_qconfigs 610# @FUNCTION: generate_qconfigs
611# @INTERNAL
609# @DESCRIPTION: 612# @DESCRIPTION:
610# Generates gentoo-specific configurations 613# Generates gentoo-specific qconfig.{h,pri}.
611generate_qconfigs() { 614generate_qconfigs() {
612 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 615 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then
613 local x qconfig_add qconfig_remove qconfig_new 616 local x qconfig_add qconfig_remove qconfig_new
614 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 617 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
615 [[ -f ${x} ]] || continue 618 [[ -f ${x} ]] || continue
664 fi 667 fi
665} 668}
666 669
667# @FUNCTION: qt4-build_pkg_postrm 670# @FUNCTION: qt4-build_pkg_postrm
668# @DESCRIPTION: 671# @DESCRIPTION:
669# Generate configurations when the package is completely removed 672# Regenerate configuration when the package is completely removed.
670qt4-build_pkg_postrm() { 673qt4-build_pkg_postrm() {
671 generate_qconfigs 674 generate_qconfigs
672} 675}
673 676
674# @FUNCTION: qt4-build_pkg_postinst 677# @FUNCTION: qt4-build_pkg_postinst
675# @DESCRIPTION: 678# @DESCRIPTION:
676# Generate configuration, plus throws a message about possible 679# Regenerate configuration, plus throw a message about possible
677# breakages and proposed solutions. 680# breakages and proposed solutions.
678qt4-build_pkg_postinst() { 681qt4-build_pkg_postinst() {
679 generate_qconfigs 682 generate_qconfigs
680} 683}
681 684
682# @FUNCTION: skip_qmake_build 685# @FUNCTION: skip_qmake_build
686# @INTERNAL
683# @DESCRIPTION: 687# @DESCRIPTION:
684# Don't need to build qmake, as it's already installed from qt-core 688# Patches configure to skip qmake compilation, as it's already installed by qt-core.
685skip_qmake_build() { 689skip_qmake_build() {
686 # Don't need to build qmake, as it's already installed from qt-core
687 sed -i -e "s:if true:if false:g" "${S}"/configure || die "sed failed" 690 sed -i -e "s:if true:if false:g" "${S}"/configure || die
688} 691}
689 692
690# @FUNCTION: skip_project_generation 693# @FUNCTION: skip_project_generation
694# @INTERNAL
691# @DESCRIPTION: 695# @DESCRIPTION:
692# Exit the script early by throwing in an exit before all of the .pro files are scanned 696# Exit the script early by throwing in an exit before all of the .pro files are scanned.
693skip_project_generation() { 697skip_project_generation() {
694 # Exit the script early by throwing in an exit before all of the .pro files are scanned
695 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 698 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
696 -i "${S}"/configure || die "sed failed"
697} 699}
698 700
699# @FUNCTION: symlink_binaries_to_buildtree 701# @FUNCTION: symlink_binaries_to_buildtree
702# @INTERNAL
700# @DESCRIPTION: 703# @DESCRIPTION:
701# Symlink generated binaries to buildtree so they can be used during compilation 704# Symlinks generated binaries to buildtree, so they can be used during compilation time.
702# time
703symlink_binaries_to_buildtree() { 705symlink_binaries_to_buildtree() {
704 for bin in qmake moc uic rcc; do 706 for bin in qmake moc uic rcc; do
705 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed" 707 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
706 done 708 done
707} 709}
708 710
709# @FUNCTION: fix_library_files 711# @FUNCTION: fix_library_files
712# @INTERNAL
710# @DESCRIPTION: 713# @DESCRIPTION:
711# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 714# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
712# moves the *.pc-files into the pkgconfig directory 715# moves the *.pc files into the pkgconfig directory.
713fix_library_files() { 716fix_library_files() {
717 local libfile
714 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 718 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
715 if [[ -e ${libfile} ]]; then 719 if [[ -e ${libfile} ]]; then
716 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed" 720 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
717 fi 721 fi
718 done 722 done
719 723
720 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 724 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
721 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 725 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
722 if [[ -e ${libfile} ]]; then 726 if [[ -e ${libfile} ]]; then
723 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed failed" 727 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
724 728
725 # Move .pc files into the pkgconfig directory 729 # Move .pc files into the pkgconfig directory
726 dodir ${QTPCDIR#${EPREFIX}} 730 dodir ${QTPCDIR#${EPREFIX}}
727 mv ${libfile} "${D}"/${QTPCDIR}/ \ 731 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
728 || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
729 fi 732 fi
730 done 733 done
731 734
732 # Don't install an empty directory 735 # Don't install an empty directory
733 rmdir "${D}"/${QTLIBDIR}/pkgconfig 736 rmdir "${D}"/${QTLIBDIR}/pkgconfig
734} 737}
735 738
736# @FUNCTION: qt_use 739# @FUNCTION: qt_use
737# @USAGE: < flag > [ feature ] [ enableval ] 740# @USAGE: < flag > [ feature ] [ enableval ]
738# @DESCRIPTION: 741# @DESCRIPTION:
739# This will echo "${enableval}-${feature}" if <flag> is enabled, or 742# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
740# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 743# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
741# will be used for that. If [enableval] is not specified, it omits the 744# will be used for that. If [enableval] is not specified, it omits the
742# assignment-part 745# "-${enableval}" part.
743qt_use() { 746qt_use() {
744 local flag=$1 747 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
745 local feature=$1
746 local enableval=
747
748 [[ -n $2 ]] && feature=$2
749 [[ -n $3 ]] && enableval=-$3
750
751 if use ${flag}; then
752 echo "${enableval}-${feature}"
753 else
754 echo "-no-${feature}"
755 fi
756} 748}
757 749
758# @FUNCTION: qt_mkspecs_dir 750# @FUNCTION: qt_mkspecs_dir
759# @RETURN: the specs-directory w/o path 751# @RETURN: the specs-directory w/o path
760# @DESCRIPTION: 752# @DESCRIPTION:
761# Allows us to define which mkspecs dir we want to use. 753# Allows us to define which mkspecs dir we want to use.
762qt_mkspecs_dir() { 754qt_mkspecs_dir() {
763 # Allows us to define which mkspecs dir we want to use.
764 local spec 755 local spec=
765
766 case ${CHOST} in 756 case ${CHOST} in
767 *-freebsd*|*-dragonfly*) 757 *-freebsd*|*-dragonfly*)
768 spec=freebsd ;; 758 spec=freebsd ;;
769 *-openbsd*) 759 *-openbsd*)
770 spec=openbsd ;; 760 spec=openbsd ;;
793 elif [[ ${CXX} == *icpc* ]]; then 783 elif [[ ${CXX} == *icpc* ]]; then
794 spec+=-icc 784 spec+=-icc
795 else 785 else
796 die "Unknown compiler '${CXX}'" 786 die "Unknown compiler '${CXX}'"
797 fi 787 fi
798 if [[ -n ${LIBDIR/lib} ]]; then
799 spec+=-${LIBDIR/lib}
800 fi
801 788
802 # Add -64 for 64bit profiles 789 # Add -64 for 64bit profiles
803 if use x64-freebsd || 790 if use x64-freebsd ||
804 use amd64-linux || 791 use amd64-linux ||
805 use x64-macos || 792 use x64-macos ||
811 798
812 echo "${spec}" 799 echo "${spec}"
813} 800}
814 801
815# @FUNCTION: qt_assistant_cleanup 802# @FUNCTION: qt_assistant_cleanup
816# @RETURN: nothing 803# @INTERNAL
817# @DESCRIPTION: 804# @DESCRIPTION:
818# Tries to clean up tools.pro for qt-assistant ebuilds. 805# Tries to clean up tools.pro for qt-assistant ebuilds.
819# Meant to be called in src_prepare(). 806# Meant to be called in src_prepare().
820# Since Qt 4.7.4 this function is a no-op. 807# Since Qt 4.7.4 this function is a no-op.
821qt_assistant_cleanup() { 808qt_assistant_cleanup() {
841 ;; 828 ;;
842 esac 829 esac
843} 830}
844 831
845# @FUNCTION: qt_nolibx11 832# @FUNCTION: qt_nolibx11
846# @RETURN: nothing 833# @INTERNAL
847# @DESCRIPTION: 834# @DESCRIPTION:
848# Ignore X11 tests for packages that don't need X libraries installed 835# Ignore X11 tests for packages that don't need X libraries installed.
849qt_nolibx11() { 836qt_nolibx11() {
850 einfo "Removing X11 check to allow X-less compilation"
851 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure || 837 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
852 die "x11 check sed failed" 838 die "x11 check sed failed"
853} 839}
854 840
855EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst 841EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.100  
changed lines
  Added in v.1.121

  ViewVC Help
Powered by ViewVC 1.1.20